
#include "UnpackRLE.h"

void RLEGetUnpackedSize(const unsigned char * inBuffer, unsigned long* nSize) {
  unsigned long lSize =  inBuffer[0x1] |
              (inBuffer[0x2]*256) |
              (inBuffer[0x3]*65536);
  *nSize = lSize;
}


// performs decompression of Run-Length Encoded data.
// pDataSrc - pointer to source data
// nUncompressedDataSize - size of the uncompressed data
// pDataDest - pointer to the storage space for the decompressed data
void RLEUnCompWRAM(const unsigned char *pDataSrc, unsigned char *pDataDest) {
  // decompress from the source to the destination...
// this is how it should be done on the GBA... if it worked :(
//  asm volatile(
//    "mov r0, %0 \n mov r1, %1 \n  swi 0x140000 ": 
//    /* No output */ :
//    "r" (pDataSrc) , "r" (pDataDest) : 
//    "r0", "r1");
  
  // reverse the compression process... 
  unsigned long nCompressedPos = 4; // index into the source compressed array 
  unsigned long nDecompressedPos = 0; // index into the destination decompressed array
  unsigned char j; // loop
  unsigned long nUncompressedDataSize = pDataSrc[0x1] | (pDataSrc[0x2]*256) | (pDataSrc[0x3]*65536);
  
  while (nDecompressedPos < nUncompressedDataSize) {
    if ( (pDataSrc[nCompressedPos] & 1<<7) > 0) {
      // compressed data follows 
      // get the amount
      unsigned char nDataCount = ((pDataSrc[nCompressedPos] & 0x7F)+3);
      nCompressedPos++;
      // add to the out stream
      for (j = 0; j < nDataCount; j++) {
        pDataDest[nDecompressedPos] = pDataSrc[nCompressedPos];
        nDecompressedPos++;
      }
      nCompressedPos++;
      
    } else {
      // uncompressed data follows
      // how many bytes?
      unsigned char nDataCount = (pDataSrc[nCompressedPos] & 0x7F) + 1;
      nCompressedPos++;
      
      // copy these uncompressed bytes from the in bytes to the out bytes
      for (j = 0; j < nDataCount; j++) {
        pDataDest[nDecompressedPos] = pDataSrc[nCompressedPos];
        nCompressedPos++;
        nDecompressedPos++;
      }
      
    }
    
  }
  
  
}

