#include "keypad.h"
volatile u32* KEYS = (volatile u32*)0x04000130;

u32 thisKeys;
u32 lastKeys;
u32 repeated[10];

extern void wait_vsync_int();


int KeyPressed(u16 key) {
  if (!(thisKeys & key))
    return 1;
  return 0;
}

int KeyPressedNoBounce(u16 key, u32 r){
  u8 keyindex;
  switch(key) {
    case KEY_A 		  : keyindex = 0; break;
    case KEY_B      : keyindex = 1; break;
    case KEY_SELECT : keyindex = 2; break;
    case KEY_START  : keyindex = 3; break;
    case KEY_RIGHT  : keyindex = 4; break;
    case KEY_LEFT   : keyindex = 5; break;
    case KEY_UP     : keyindex = 6; break;
    case KEY_DOWN   : keyindex = 7; break;
    case KEY_R      : keyindex = 8; break;
    case KEY_L 		  : keyindex = 9; break;
    default : return 0;
  }
  
  if (!(thisKeys & key)) {// if the recent poll has the key pressed
    if ((lastKeys & key) || (!(lastKeys & key)&& r < repeated[keyindex])) { // and it wasn't pressed last time..
      repeated[keyindex] = 0;
      return 1;
    }
    else if (!(lastKeys & key))
      repeated[keyindex]++;
  }
    
  return 0;
}
void InitKeys(void) {
  lastKeys = 0xFFFF;
  thisKeys = 0xFFFF;

}

void UpdateKeys(void){
  lastKeys = thisKeys;
  thisKeys = *KEYS;

}

void WaitKeyReleased(int key) {
  UpdateKeys();
  while(KeyPressed(key)) {
    wait_vsync_int();
    UpdateKeys();
  }
}
void WaitKeyPress(int key) {
  UpdateKeys();
  while (!KeyPressed(key)) {
    UpdateKeys();
    wait_vsync_int();
  }
  WaitKeyReleased(key);
}
