/******************\
*   Keypad.h       *
*   by dovoto      *
*                  *
\******************/

#ifndef KEYPAD_H
#define KEYPAD_H
#include "gba.h"
#define KEY_A 		1
#define KEY_B 		2
#define KEY_SELECT	4
#define KEY_START 	8
#define KEY_RIGHT 	16
#define KEY_LEFT 		32
#define KEY_UP 		64
#define KEY_DOWN 		128
#define KEY_R		256
#define KEY_L 		512
extern volatile u32* KEYS;


/*Call these 2 only once V_BLANK interrupts are on!!*/
void WaitKeyReleased(int key);
void WaitKeyPress(int key);


void InitKeys(void);
void UpdateKeys(void);
int KeyPressed(u16 key);
int KeyPressedNoBounce(u16 key, u32 r);


#endif
